package  {
	
	import flash.display.Bitmap;
	import flash.display.GradientType;
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.media.Sound;

	public class TreePage extends Sprite {
		
		[Embed(source = "../lib/star.png")]
		public var Star:Class;
		
		[Embed(source = "../lib/song.mp3")]
		public var Music:Class;
		
		public function TreePage() {
			drawGradient();
			drawTree();
			startSnow();
			playMusic();
			
		}
		
		private function playMusic():void {
			var snd:Sound = new Music() as Sound;
			snd.play(0, 9999);
			
		}
		
		private function startSnow():void {
			for (var i:int = 0; i < 100; i++) {
				addChild(new Flake());
			}
			
			addEventListener(Event.ENTER_FRAME, onFrame);
		}
		
		private function onFrame(e:Event):void {
			Flake.phase += 0.05 *Math.random();
			Flake.wind = Math.sin(Flake.phase)/2;
		}
		
		private function drawTree():void {
			var offset:Number = 200;
			
			for (var i:Number = 10; i <= 120; i += 10) {
				drawTriangle(offset, i);
				offset += i/3;
			}
			
			var canvas:Graphics = graphics;
			canvas.beginFill(0x663F0F);
			canvas.drawRect(
				200 - 15,
				offset + (i - 10) * 2 / 3,
				30,
				30
			);
			
			canvas.endFill();
			
			var star:Bitmap = new Star() as Bitmap;
			star.scaleX = star.scaleY = 1 / 5;
			star.smoothing = true;
			star.x = 150;
			star.y = 140;
			addChild(star);
		}
		
		private function drawTriangle(offset:Number, i:Number):void {
			var canvas:Graphics = graphics;
			canvas.beginFill(0x008000);
			canvas.moveTo(200, offset);
			canvas.lineTo(200 + i*i/89, offset + i);
			canvas.lineTo(200 - i*i/89 , offset + i);
			canvas.lineTo(200, offset);
		
		}
		
		private function drawGradient():void {
			var mtrx:Matrix = new Matrix();
			mtrx.createGradientBox(400, 600, Math.PI/2);
			
			graphics.beginGradientFill(
				GradientType.LINEAR,
				[0xAAD2FB, 0x03203D],
				[1, 1],
				[0x00, 0xFF],
				mtrx
			);
			
			graphics.drawRect(0, 0, 400, 600);
			graphics.endFill();
		}
		
	}

}